#ifndef _H_6F997971DEBB9028F54EF36DD5EF4F7C_LaneModels_DCPS_H_
#define _H_6F997971DEBB9028F54EF36DD5EF4F7C_LaneModels_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "LaneModels_.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class LaneModels_TypeSupportInterface;

            typedef LaneModels_TypeSupportInterface * LaneModels_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < LaneModels_TypeSupportInterface> LaneModels_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < LaneModels_TypeSupportInterface> LaneModels_TypeSupportInterface_out;


            class LaneModels_DataWriter;

            typedef LaneModels_DataWriter * LaneModels_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < LaneModels_DataWriter> LaneModels_DataWriter_var;
            typedef DDS_DCPSInterface_out < LaneModels_DataWriter> LaneModels_DataWriter_out;


            class LaneModels_DataReader;

            typedef LaneModels_DataReader * LaneModels_DataReader_ptr;
            typedef DDS_DCPSInterface_var < LaneModels_DataReader> LaneModels_DataReader_var;
            typedef DDS_DCPSInterface_out < LaneModels_DataReader> LaneModels_DataReader_out;


            class LaneModels_DataReaderView;

            typedef LaneModels_DataReaderView * LaneModels_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < LaneModels_DataReaderView> LaneModels_DataReaderView_var;
            typedef DDS_DCPSInterface_out < LaneModels_DataReaderView> LaneModels_DataReaderView_out;

            struct LaneModels_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < LaneModels_, struct LaneModels_Seq_uniq_> LaneModels_Seq;
            typedef DDS_DCPSSequence_var < LaneModels_Seq> LaneModels_Seq_var;
            typedef DDS_DCPSSequence_out < LaneModels_Seq> LaneModels_Seq_out;

            class  LaneModels_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef LaneModels_TypeSupportInterface_ptr _ptr_type;
                typedef LaneModels_TypeSupportInterface_var _var_type;

                static LaneModels_TypeSupportInterface_ptr _duplicate (LaneModels_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneModels_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static LaneModels_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneModels_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneModels_TypeSupportInterface_ptr _this () { return this; }


            protected:
                LaneModels_TypeSupportInterface () {};
                ~LaneModels_TypeSupportInterface () {};
            private:
                LaneModels_TypeSupportInterface (const LaneModels_TypeSupportInterface &);
                LaneModels_TypeSupportInterface & operator = (const LaneModels_TypeSupportInterface &);
            };

            class  LaneModels_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef LaneModels_DataWriter_ptr _ptr_type;
                typedef LaneModels_DataWriter_var _var_type;

                static LaneModels_DataWriter_ptr _duplicate (LaneModels_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneModels_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static LaneModels_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneModels_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneModels_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const LaneModels_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const LaneModels_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const LaneModels_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const LaneModels_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const LaneModels_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const LaneModels_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const LaneModels_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const LaneModels_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const LaneModels_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const LaneModels_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (LaneModels_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneModels_& instance_data) = 0;

            protected:
                LaneModels_DataWriter () {};
                ~LaneModels_DataWriter () {};
            private:
                LaneModels_DataWriter (const LaneModels_DataWriter &);
                LaneModels_DataWriter & operator = (const LaneModels_DataWriter &);
            };

            class  LaneModels_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef LaneModels_DataReader_ptr _ptr_type;
                typedef LaneModels_DataReader_var _var_type;

                static LaneModels_DataReader_ptr _duplicate (LaneModels_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneModels_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static LaneModels_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneModels_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneModels_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LaneModels_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LaneModels_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LaneModels_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneModels_& instance) = 0;

            protected:
                LaneModels_DataReader () {};
                ~LaneModels_DataReader () {};
            private:
                LaneModels_DataReader (const LaneModels_DataReader &);
                LaneModels_DataReader & operator = (const LaneModels_DataReader &);
            };

            class  LaneModels_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef LaneModels_DataReaderView_ptr _ptr_type;
                typedef LaneModels_DataReaderView_var _var_type;

                static LaneModels_DataReaderView_ptr _duplicate (LaneModels_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static LaneModels_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static LaneModels_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static LaneModels_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                LaneModels_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (LaneModels_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (LaneModels_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (LaneModels_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (LaneModels_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const LaneModels_& instance) = 0;

            protected:
                LaneModels_DataReaderView () {};
                ~LaneModels_DataReaderView () {};
            private:
                LaneModels_DataReaderView (const LaneModels_DataReaderView &);
                LaneModels_DataReaderView & operator = (const LaneModels_DataReaderView &);
            };
        }

    }

}

#endif
