#ifndef H_ED0A9DAF2E826B22FF9F40E6035064ED_ObjectWithCovariance_SPLTYPES_H
#define H_ED0A9DAF2E826B22FF9F40E6035064ED_ObjectWithCovariance_SPLTYPES_H

#include <c_base.h>
#include <c_misc.h>
#include <c_sync.h>
#include <c_collection.h>
#include <c_field.h>
#include <v_copyIn.h>

#include "ccpp_ObjectWithCovariance_.h"
#include "std_msgs/msg/dds_opensplice/Header_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/PoseWithCovariance_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/TwistWithCovariance_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/AccelWithCovariance_SplDcps.h"
#include "geometry_msgs/msg/dds_opensplice/Polygon_SplDcps.h"
#include "derived_object_msgs/msg/dds_opensplice/SolidPrimitiveWithCovariance_SplDcps.h"



extern c_metaObject __ObjectWithCovariance__derived_object_msgs__load (c_base base);

extern c_metaObject __ObjectWithCovariance__derived_object_msgs_msg__load (c_base base);

extern c_metaObject __ObjectWithCovariance__derived_object_msgs_msg_dds___load (c_base base);

extern c_metaObject __ObjectWithCovariance__derived_object_msgs_msg_dds__ObjectWithCovariance_Constants__load (c_base base);

extern const char *derived_object_msgs_msg_dds__ObjectWithCovariance__metaDescriptor[];
extern const int derived_object_msgs_msg_dds__ObjectWithCovariance__metaDescriptorArrLength;
extern const int derived_object_msgs_msg_dds__ObjectWithCovariance__metaDescriptorLength;
extern c_metaObject __derived_object_msgs_msg_dds__ObjectWithCovariance___load (c_base base);
struct _derived_object_msgs_msg_dds__ObjectWithCovariance_ ;
extern  v_copyin_result __derived_object_msgs_msg_dds__ObjectWithCovariance___copyIn(c_base base, const struct derived_object_msgs::msg::dds_::ObjectWithCovariance_ *from, struct _derived_object_msgs_msg_dds__ObjectWithCovariance_ *to);
extern  void __derived_object_msgs_msg_dds__ObjectWithCovariance___copyOut(const void *_from, void *_to);
struct _derived_object_msgs_msg_dds__ObjectWithCovariance_ {
    struct _std_msgs_msg_dds__Header_ header_;
    c_ulong id_;
    c_octet detection_level_;
    c_bool object_classified_;
    struct _geometry_msgs_msg_dds__PoseWithCovariance_ pose_;
    struct _geometry_msgs_msg_dds__TwistWithCovariance_ twist_;
    struct _geometry_msgs_msg_dds__AccelWithCovariance_ accel_;
    struct _geometry_msgs_msg_dds__Polygon_ polygon_;
    struct _derived_object_msgs_msg_dds__SolidPrimitiveWithCovariance_ shape_;
    c_octet classification_;
    c_octet classification_certainty_;
    c_ulong classification_age_;
};

#undef OS_API
#endif
