#ifndef _H_600707F24623BFB84AC805EE1576DDBD_SolidPrimitiveWithCovariance__H_
#define _H_600707F24623BFB84AC805EE1576DDBD_SolidPrimitiveWithCovariance__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace SolidPrimitiveWithCovariance_Constants
            {
                const ::DDS::Octet BOX_ = 1;

                const ::DDS::Octet SPHERE_ = 2;

                const ::DDS::Octet CYLINDER_ = 3;

                const ::DDS::Octet CONE_ = 4;

                const ::DDS::Octet BOX_X_ = 0;

                const ::DDS::Octet BOX_Y_ = 1;

                const ::DDS::Octet BOX_Z_ = 2;

                const ::DDS::Octet SPHERE_RADIUS_ = 0;

                const ::DDS::Octet CYLINDER_HEIGHT_ = 0;

                const ::DDS::Octet CYLINDER_RADIUS_ = 1;

                const ::DDS::Octet CONE_HEIGHT_ = 0;

                const ::DDS::Octet CONE_RADIUS_ = 1;

            }

            struct  SolidPrimitiveWithCovariance_
            {
                struct _dimensions__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Double, struct _dimensions__seq_uniq_ > _dimensions__seq;
                typedef DDS_DCPSSequence_var< _dimensions__seq > _dimensions__seq_var;
                typedef DDS_DCPSSequence_out< _dimensions__seq > _dimensions__seq_out;
                struct _covariance__seq_uniq_{};
                typedef DDS_DCPSUFLSeq< ::DDS::Double, struct _covariance__seq_uniq_ > _covariance__seq;
                typedef DDS_DCPSSequence_var< _covariance__seq > _covariance__seq_var;
                typedef DDS_DCPSSequence_out< _covariance__seq > _covariance__seq_out;
                ::DDS::Octet type_;
                _dimensions__seq dimensions_;
                _covariance__seq covariance_;
            };

            typedef DDS_DCPSStruct_var<SolidPrimitiveWithCovariance_> SolidPrimitiveWithCovariance__var;
            typedef DDS_DCPSStruct_out < SolidPrimitiveWithCovariance_> SolidPrimitiveWithCovariance__out;

        }

    }

}

#endif /* _H_600707F24623BFB84AC805EE1576DDBD_SolidPrimitiveWithCovariance__H_ */
