#ifndef _H_A87B1912D8DFDCB75AA1626174A85E5B_Lane__H_
#define _H_A87B1912D8DFDCB75AA1626174A85E5B_Lane__H_

#include "sacpp_mapping.h"
#include "cpp_dcps_if.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            namespace Lane_Constants
            {
                const ::DDS::Octet LANE_QUALITY_INVALID_ = 0;

                const ::DDS::Octet LANE_QUALITY_UNKNOWN_ = 1;

                const ::DDS::Octet LANE_QUALITY_NOT_AVAILABLE_ = 2;

                const ::DDS::Octet LANE_QUALITY_0_ = 3;

                const ::DDS::Octet LANE_QUALITY_1_ = 4;

                const ::DDS::Octet LANE_QUALITY_2_ = 5;

                const ::DDS::Octet LANE_QUALITY_3_ = 6;

                const ::DDS::Octet LANE_QUALITY_4_ = 7;

                const ::DDS::Octet LANE_QUALITY_5_ = 8;

                const ::DDS::Octet LANE_QUALITY_6_ = 9;

                const ::DDS::Octet LANE_QUALITY_7_ = 10;

                const ::DDS::Octet LANE_QUALITY_8_ = 11;

                const ::DDS::Octet LANE_QUALITY_9_ = 12;

                const ::DDS::Octet LANE_QUALITY_KIND_COUNT_ = 13;

                const ::DDS::Octet LANE_MARKER_INVALID_ = 0;

                const ::DDS::Octet LANE_MARKER_UNKNOWN_ = 1;

                const ::DDS::Octet LANE_MARKER_NOT_AVAILABLE_ = 2;

                const ::DDS::Octet LANE_MARKER_NONE_ = 3;

                const ::DDS::Octet LANE_MARKER_SOLID_ = 4;

                const ::DDS::Octet LANE_MARKER_DASHED_ = 5;

                const ::DDS::Octet LANE_MARKER_VIRTUAL_ = 6;

                const ::DDS::Octet LANE_MARKER_DOTS_ = 7;

                const ::DDS::Octet LANE_MARKER_ROAD_EDGE_ = 8;

                const ::DDS::Octet LANE_MARKER_DOUBLE_LINE_ = 9;

                const ::DDS::Octet LANE_MARKER_KIND_COUNT_ = 10;

                const ::DDS::Octet LANE_CURVE_MODEL_INVALID_ = 0;

                const ::DDS::Octet LANE_CURVE_MODEL_UNKNOWN_ = 1;

                const ::DDS::Octet LANE_CURVE_MODEL_NOT_AVAILABLE_ = 2;

                const ::DDS::Octet LANE_CURVE_MODEL_LINEAR_ = 3;

                const ::DDS::Octet LANE_CURVE_MODEL_PARABOLIC_ = 4;

                const ::DDS::Octet LANE_CURVE_MODEL_3D_ = 5;

                const ::DDS::Octet LANE_CURVE_MODEL_KIND_COUNT_ = 6;

            }

            struct  Lane_
            {
                ::DDS::Octet quality_;
                ::DDS::Octet marker_kind_;
                ::DDS::Octet curve_model_kind_;
                ::DDS::Double marker_offset_;
                ::DDS::Double heading_angle_;
                ::DDS::Double curvature_;
                ::DDS::Double curvature_derivative_;
                ::DDS::Double marker_width_;
                ::DDS::Double view_range_;
            };

            typedef DDS_DCPSStruct_var<Lane_> Lane__var;
            typedef Lane_& Lane__out;

        }

    }

}

#endif /* _H_A87B1912D8DFDCB75AA1626174A85E5B_Lane__H_ */
