#ifndef _H_A87B1912D8DFDCB75AA1626174A85E5B_Lane_DCPS_H_
#define _H_A87B1912D8DFDCB75AA1626174A85E5B_Lane_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Lane_.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Lane_TypeSupportInterface;

            typedef Lane_TypeSupportInterface * Lane_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Lane_TypeSupportInterface> Lane_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Lane_TypeSupportInterface> Lane_TypeSupportInterface_out;


            class Lane_DataWriter;

            typedef Lane_DataWriter * Lane_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Lane_DataWriter> Lane_DataWriter_var;
            typedef DDS_DCPSInterface_out < Lane_DataWriter> Lane_DataWriter_out;


            class Lane_DataReader;

            typedef Lane_DataReader * Lane_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Lane_DataReader> Lane_DataReader_var;
            typedef DDS_DCPSInterface_out < Lane_DataReader> Lane_DataReader_out;


            class Lane_DataReaderView;

            typedef Lane_DataReaderView * Lane_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Lane_DataReaderView> Lane_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Lane_DataReaderView> Lane_DataReaderView_out;

            struct Lane_Seq_uniq_ {};
            typedef DDS_DCPSUFLSeq < Lane_, struct Lane_Seq_uniq_> Lane_Seq;
            typedef DDS_DCPSSequence_var < Lane_Seq> Lane_Seq_var;
            typedef DDS_DCPSSequence_out < Lane_Seq> Lane_Seq_out;

            class  Lane_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Lane_TypeSupportInterface_ptr _ptr_type;
                typedef Lane_TypeSupportInterface_var _var_type;

                static Lane_TypeSupportInterface_ptr _duplicate (Lane_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Lane_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Lane_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Lane_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Lane_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Lane_TypeSupportInterface () {};
                ~Lane_TypeSupportInterface () {};
            private:
                Lane_TypeSupportInterface (const Lane_TypeSupportInterface &);
                Lane_TypeSupportInterface & operator = (const Lane_TypeSupportInterface &);
            };

            class  Lane_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Lane_DataWriter_ptr _ptr_type;
                typedef Lane_DataWriter_var _var_type;

                static Lane_DataWriter_ptr _duplicate (Lane_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Lane_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Lane_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Lane_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Lane_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Lane_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Lane_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Lane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Lane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Lane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Lane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Lane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Lane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Lane_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Lane_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Lane_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Lane_& instance_data) = 0;

            protected:
                Lane_DataWriter () {};
                ~Lane_DataWriter () {};
            private:
                Lane_DataWriter (const Lane_DataWriter &);
                Lane_DataWriter & operator = (const Lane_DataWriter &);
            };

            class  Lane_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Lane_DataReader_ptr _ptr_type;
                typedef Lane_DataReader_var _var_type;

                static Lane_DataReader_ptr _duplicate (Lane_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Lane_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Lane_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Lane_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Lane_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Lane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Lane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Lane_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Lane_& instance) = 0;

            protected:
                Lane_DataReader () {};
                ~Lane_DataReader () {};
            private:
                Lane_DataReader (const Lane_DataReader &);
                Lane_DataReader & operator = (const Lane_DataReader &);
            };

            class  Lane_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Lane_DataReaderView_ptr _ptr_type;
                typedef Lane_DataReaderView_var _var_type;

                static Lane_DataReaderView_ptr _duplicate (Lane_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Lane_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Lane_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Lane_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Lane_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Lane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Lane_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Lane_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Lane_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Lane_& instance) = 0;

            protected:
                Lane_DataReaderView () {};
                ~Lane_DataReaderView () {};
            private:
                Lane_DataReaderView (const Lane_DataReaderView &);
                Lane_DataReaderView & operator = (const Lane_DataReaderView &);
            };
        }

    }

}

#endif
