#ifndef _H_82CD095CD35D7EEA4B342FD365244346_ObjectWithCovarianceArray_DCPS_H_
#define _H_82CD095CD35D7EEA4B342FD365244346_ObjectWithCovarianceArray_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectWithCovarianceArray_.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectWithCovarianceArray_TypeSupportInterface;

            typedef ObjectWithCovarianceArray_TypeSupportInterface * ObjectWithCovarianceArray_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovarianceArray_TypeSupportInterface> ObjectWithCovarianceArray_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovarianceArray_TypeSupportInterface> ObjectWithCovarianceArray_TypeSupportInterface_out;


            class ObjectWithCovarianceArray_DataWriter;

            typedef ObjectWithCovarianceArray_DataWriter * ObjectWithCovarianceArray_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovarianceArray_DataWriter> ObjectWithCovarianceArray_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovarianceArray_DataWriter> ObjectWithCovarianceArray_DataWriter_out;


            class ObjectWithCovarianceArray_DataReader;

            typedef ObjectWithCovarianceArray_DataReader * ObjectWithCovarianceArray_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovarianceArray_DataReader> ObjectWithCovarianceArray_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovarianceArray_DataReader> ObjectWithCovarianceArray_DataReader_out;


            class ObjectWithCovarianceArray_DataReaderView;

            typedef ObjectWithCovarianceArray_DataReaderView * ObjectWithCovarianceArray_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovarianceArray_DataReaderView> ObjectWithCovarianceArray_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovarianceArray_DataReaderView> ObjectWithCovarianceArray_DataReaderView_out;

            struct ObjectWithCovarianceArray_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectWithCovarianceArray_, struct ObjectWithCovarianceArray_Seq_uniq_> ObjectWithCovarianceArray_Seq;
            typedef DDS_DCPSSequence_var < ObjectWithCovarianceArray_Seq> ObjectWithCovarianceArray_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectWithCovarianceArray_Seq> ObjectWithCovarianceArray_Seq_out;

            class  ObjectWithCovarianceArray_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectWithCovarianceArray_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectWithCovarianceArray_TypeSupportInterface_var _var_type;

                static ObjectWithCovarianceArray_TypeSupportInterface_ptr _duplicate (ObjectWithCovarianceArray_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovarianceArray_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovarianceArray_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectWithCovarianceArray_TypeSupportInterface () {};
                ~ObjectWithCovarianceArray_TypeSupportInterface () {};
            private:
                ObjectWithCovarianceArray_TypeSupportInterface (const ObjectWithCovarianceArray_TypeSupportInterface &);
                ObjectWithCovarianceArray_TypeSupportInterface & operator = (const ObjectWithCovarianceArray_TypeSupportInterface &);
            };

            class  ObjectWithCovarianceArray_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectWithCovarianceArray_DataWriter_ptr _ptr_type;
                typedef ObjectWithCovarianceArray_DataWriter_var _var_type;

                static ObjectWithCovarianceArray_DataWriter_ptr _duplicate (ObjectWithCovarianceArray_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovarianceArray_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovarianceArray_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectWithCovarianceArray_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectWithCovarianceArray_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectWithCovarianceArray_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectWithCovarianceArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectWithCovarianceArray_& instance_data) = 0;

            protected:
                ObjectWithCovarianceArray_DataWriter () {};
                ~ObjectWithCovarianceArray_DataWriter () {};
            private:
                ObjectWithCovarianceArray_DataWriter (const ObjectWithCovarianceArray_DataWriter &);
                ObjectWithCovarianceArray_DataWriter & operator = (const ObjectWithCovarianceArray_DataWriter &);
            };

            class  ObjectWithCovarianceArray_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectWithCovarianceArray_DataReader_ptr _ptr_type;
                typedef ObjectWithCovarianceArray_DataReader_var _var_type;

                static ObjectWithCovarianceArray_DataReader_ptr _duplicate (ObjectWithCovarianceArray_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovarianceArray_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovarianceArray_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectWithCovarianceArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectWithCovarianceArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectWithCovarianceArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectWithCovarianceArray_& instance) = 0;

            protected:
                ObjectWithCovarianceArray_DataReader () {};
                ~ObjectWithCovarianceArray_DataReader () {};
            private:
                ObjectWithCovarianceArray_DataReader (const ObjectWithCovarianceArray_DataReader &);
                ObjectWithCovarianceArray_DataReader & operator = (const ObjectWithCovarianceArray_DataReader &);
            };

            class  ObjectWithCovarianceArray_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectWithCovarianceArray_DataReaderView_ptr _ptr_type;
                typedef ObjectWithCovarianceArray_DataReaderView_var _var_type;

                static ObjectWithCovarianceArray_DataReaderView_ptr _duplicate (ObjectWithCovarianceArray_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovarianceArray_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovarianceArray_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovarianceArray_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectWithCovarianceArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectWithCovarianceArray_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectWithCovarianceArray_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectWithCovarianceArray_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectWithCovarianceArray_& instance) = 0;

            protected:
                ObjectWithCovarianceArray_DataReaderView () {};
                ~ObjectWithCovarianceArray_DataReaderView () {};
            private:
                ObjectWithCovarianceArray_DataReaderView (const ObjectWithCovarianceArray_DataReaderView &);
                ObjectWithCovarianceArray_DataReaderView & operator = (const ObjectWithCovarianceArray_DataReaderView &);
            };
        }

    }

}

#endif
