#ifndef _H_ED0A9DAF2E826B22FF9F40E6035064ED_ObjectWithCovariance_DCPS_H_
#define _H_ED0A9DAF2E826B22FF9F40E6035064ED_ObjectWithCovariance_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "ObjectWithCovariance_.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class ObjectWithCovariance_TypeSupportInterface;

            typedef ObjectWithCovariance_TypeSupportInterface * ObjectWithCovariance_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovariance_TypeSupportInterface> ObjectWithCovariance_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovariance_TypeSupportInterface> ObjectWithCovariance_TypeSupportInterface_out;


            class ObjectWithCovariance_DataWriter;

            typedef ObjectWithCovariance_DataWriter * ObjectWithCovariance_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovariance_DataWriter> ObjectWithCovariance_DataWriter_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovariance_DataWriter> ObjectWithCovariance_DataWriter_out;


            class ObjectWithCovariance_DataReader;

            typedef ObjectWithCovariance_DataReader * ObjectWithCovariance_DataReader_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovariance_DataReader> ObjectWithCovariance_DataReader_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovariance_DataReader> ObjectWithCovariance_DataReader_out;


            class ObjectWithCovariance_DataReaderView;

            typedef ObjectWithCovariance_DataReaderView * ObjectWithCovariance_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < ObjectWithCovariance_DataReaderView> ObjectWithCovariance_DataReaderView_var;
            typedef DDS_DCPSInterface_out < ObjectWithCovariance_DataReaderView> ObjectWithCovariance_DataReaderView_out;

            struct ObjectWithCovariance_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < ObjectWithCovariance_, struct ObjectWithCovariance_Seq_uniq_> ObjectWithCovariance_Seq;
            typedef DDS_DCPSSequence_var < ObjectWithCovariance_Seq> ObjectWithCovariance_Seq_var;
            typedef DDS_DCPSSequence_out < ObjectWithCovariance_Seq> ObjectWithCovariance_Seq_out;

            class  ObjectWithCovariance_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef ObjectWithCovariance_TypeSupportInterface_ptr _ptr_type;
                typedef ObjectWithCovariance_TypeSupportInterface_var _var_type;

                static ObjectWithCovariance_TypeSupportInterface_ptr _duplicate (ObjectWithCovariance_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovariance_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovariance_TypeSupportInterface_ptr _this () { return this; }


            protected:
                ObjectWithCovariance_TypeSupportInterface () {};
                ~ObjectWithCovariance_TypeSupportInterface () {};
            private:
                ObjectWithCovariance_TypeSupportInterface (const ObjectWithCovariance_TypeSupportInterface &);
                ObjectWithCovariance_TypeSupportInterface & operator = (const ObjectWithCovariance_TypeSupportInterface &);
            };

            class  ObjectWithCovariance_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef ObjectWithCovariance_DataWriter_ptr _ptr_type;
                typedef ObjectWithCovariance_DataWriter_var _var_type;

                static ObjectWithCovariance_DataWriter_ptr _duplicate (ObjectWithCovariance_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovariance_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovariance_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const ObjectWithCovariance_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const ObjectWithCovariance_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const ObjectWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const ObjectWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const ObjectWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const ObjectWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const ObjectWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const ObjectWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const ObjectWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const ObjectWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (ObjectWithCovariance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectWithCovariance_& instance_data) = 0;

            protected:
                ObjectWithCovariance_DataWriter () {};
                ~ObjectWithCovariance_DataWriter () {};
            private:
                ObjectWithCovariance_DataWriter (const ObjectWithCovariance_DataWriter &);
                ObjectWithCovariance_DataWriter & operator = (const ObjectWithCovariance_DataWriter &);
            };

            class  ObjectWithCovariance_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef ObjectWithCovariance_DataReader_ptr _ptr_type;
                typedef ObjectWithCovariance_DataReader_var _var_type;

                static ObjectWithCovariance_DataReader_ptr _duplicate (ObjectWithCovariance_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovariance_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovariance_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectWithCovariance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectWithCovariance_& instance) = 0;

            protected:
                ObjectWithCovariance_DataReader () {};
                ~ObjectWithCovariance_DataReader () {};
            private:
                ObjectWithCovariance_DataReader (const ObjectWithCovariance_DataReader &);
                ObjectWithCovariance_DataReader & operator = (const ObjectWithCovariance_DataReader &);
            };

            class  ObjectWithCovariance_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef ObjectWithCovariance_DataReaderView_ptr _ptr_type;
                typedef ObjectWithCovariance_DataReaderView_var _var_type;

                static ObjectWithCovariance_DataReaderView_ptr _duplicate (ObjectWithCovariance_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static ObjectWithCovariance_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static ObjectWithCovariance_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                ObjectWithCovariance_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (ObjectWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (ObjectWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (ObjectWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (ObjectWithCovariance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const ObjectWithCovariance_& instance) = 0;

            protected:
                ObjectWithCovariance_DataReaderView () {};
                ~ObjectWithCovariance_DataReaderView () {};
            private:
                ObjectWithCovariance_DataReaderView (const ObjectWithCovariance_DataReaderView &);
                ObjectWithCovariance_DataReaderView & operator = (const ObjectWithCovariance_DataReaderView &);
            };
        }

    }

}

#endif
