#ifndef _H_600707F24623BFB84AC805EE1576DDBD_SolidPrimitiveWithCovariance_DCPS_H_
#define _H_600707F24623BFB84AC805EE1576DDBD_SolidPrimitiveWithCovariance_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "SolidPrimitiveWithCovariance_.h"


namespace derived_object_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class SolidPrimitiveWithCovariance_TypeSupportInterface;

            typedef SolidPrimitiveWithCovariance_TypeSupportInterface * SolidPrimitiveWithCovariance_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < SolidPrimitiveWithCovariance_TypeSupportInterface> SolidPrimitiveWithCovariance_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < SolidPrimitiveWithCovariance_TypeSupportInterface> SolidPrimitiveWithCovariance_TypeSupportInterface_out;


            class SolidPrimitiveWithCovariance_DataWriter;

            typedef SolidPrimitiveWithCovariance_DataWriter * SolidPrimitiveWithCovariance_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < SolidPrimitiveWithCovariance_DataWriter> SolidPrimitiveWithCovariance_DataWriter_var;
            typedef DDS_DCPSInterface_out < SolidPrimitiveWithCovariance_DataWriter> SolidPrimitiveWithCovariance_DataWriter_out;


            class SolidPrimitiveWithCovariance_DataReader;

            typedef SolidPrimitiveWithCovariance_DataReader * SolidPrimitiveWithCovariance_DataReader_ptr;
            typedef DDS_DCPSInterface_var < SolidPrimitiveWithCovariance_DataReader> SolidPrimitiveWithCovariance_DataReader_var;
            typedef DDS_DCPSInterface_out < SolidPrimitiveWithCovariance_DataReader> SolidPrimitiveWithCovariance_DataReader_out;


            class SolidPrimitiveWithCovariance_DataReaderView;

            typedef SolidPrimitiveWithCovariance_DataReaderView * SolidPrimitiveWithCovariance_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < SolidPrimitiveWithCovariance_DataReaderView> SolidPrimitiveWithCovariance_DataReaderView_var;
            typedef DDS_DCPSInterface_out < SolidPrimitiveWithCovariance_DataReaderView> SolidPrimitiveWithCovariance_DataReaderView_out;

            struct SolidPrimitiveWithCovariance_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < SolidPrimitiveWithCovariance_, struct SolidPrimitiveWithCovariance_Seq_uniq_> SolidPrimitiveWithCovariance_Seq;
            typedef DDS_DCPSSequence_var < SolidPrimitiveWithCovariance_Seq> SolidPrimitiveWithCovariance_Seq_var;
            typedef DDS_DCPSSequence_out < SolidPrimitiveWithCovariance_Seq> SolidPrimitiveWithCovariance_Seq_out;

            class  SolidPrimitiveWithCovariance_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef SolidPrimitiveWithCovariance_TypeSupportInterface_ptr _ptr_type;
                typedef SolidPrimitiveWithCovariance_TypeSupportInterface_var _var_type;

                static SolidPrimitiveWithCovariance_TypeSupportInterface_ptr _duplicate (SolidPrimitiveWithCovariance_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SolidPrimitiveWithCovariance_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                SolidPrimitiveWithCovariance_TypeSupportInterface_ptr _this () { return this; }


            protected:
                SolidPrimitiveWithCovariance_TypeSupportInterface () {};
                ~SolidPrimitiveWithCovariance_TypeSupportInterface () {};
            private:
                SolidPrimitiveWithCovariance_TypeSupportInterface (const SolidPrimitiveWithCovariance_TypeSupportInterface &);
                SolidPrimitiveWithCovariance_TypeSupportInterface & operator = (const SolidPrimitiveWithCovariance_TypeSupportInterface &);
            };

            class  SolidPrimitiveWithCovariance_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef SolidPrimitiveWithCovariance_DataWriter_ptr _ptr_type;
                typedef SolidPrimitiveWithCovariance_DataWriter_var _var_type;

                static SolidPrimitiveWithCovariance_DataWriter_ptr _duplicate (SolidPrimitiveWithCovariance_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SolidPrimitiveWithCovariance_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                SolidPrimitiveWithCovariance_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const SolidPrimitiveWithCovariance_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const SolidPrimitiveWithCovariance_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const SolidPrimitiveWithCovariance_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (SolidPrimitiveWithCovariance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SolidPrimitiveWithCovariance_& instance_data) = 0;

            protected:
                SolidPrimitiveWithCovariance_DataWriter () {};
                ~SolidPrimitiveWithCovariance_DataWriter () {};
            private:
                SolidPrimitiveWithCovariance_DataWriter (const SolidPrimitiveWithCovariance_DataWriter &);
                SolidPrimitiveWithCovariance_DataWriter & operator = (const SolidPrimitiveWithCovariance_DataWriter &);
            };

            class  SolidPrimitiveWithCovariance_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef SolidPrimitiveWithCovariance_DataReader_ptr _ptr_type;
                typedef SolidPrimitiveWithCovariance_DataReader_var _var_type;

                static SolidPrimitiveWithCovariance_DataReader_ptr _duplicate (SolidPrimitiveWithCovariance_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SolidPrimitiveWithCovariance_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                SolidPrimitiveWithCovariance_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SolidPrimitiveWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SolidPrimitiveWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SolidPrimitiveWithCovariance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SolidPrimitiveWithCovariance_& instance) = 0;

            protected:
                SolidPrimitiveWithCovariance_DataReader () {};
                ~SolidPrimitiveWithCovariance_DataReader () {};
            private:
                SolidPrimitiveWithCovariance_DataReader (const SolidPrimitiveWithCovariance_DataReader &);
                SolidPrimitiveWithCovariance_DataReader & operator = (const SolidPrimitiveWithCovariance_DataReader &);
            };

            class  SolidPrimitiveWithCovariance_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef SolidPrimitiveWithCovariance_DataReaderView_ptr _ptr_type;
                typedef SolidPrimitiveWithCovariance_DataReaderView_var _var_type;

                static SolidPrimitiveWithCovariance_DataReaderView_ptr _duplicate (SolidPrimitiveWithCovariance_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static SolidPrimitiveWithCovariance_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static SolidPrimitiveWithCovariance_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                SolidPrimitiveWithCovariance_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (SolidPrimitiveWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (SolidPrimitiveWithCovariance_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (SolidPrimitiveWithCovariance_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (SolidPrimitiveWithCovariance_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const SolidPrimitiveWithCovariance_& instance) = 0;

            protected:
                SolidPrimitiveWithCovariance_DataReaderView () {};
                ~SolidPrimitiveWithCovariance_DataReaderView () {};
            private:
                SolidPrimitiveWithCovariance_DataReaderView (const SolidPrimitiveWithCovariance_DataReaderView &);
                SolidPrimitiveWithCovariance_DataReaderView & operator = (const SolidPrimitiveWithCovariance_DataReaderView &);
            };
        }

    }

}

#endif
